Steppers

Bootstrap Steps (stepper)

Note: We are transitioning MDB4 to a legacy version and focusing on developing MDB5. While we'll continue to support for the transition period, we encourage you to migrate to MDB5. We're offering a huge discount on MDB5 PRO to help with your transition, enabling you to leverage the full potential of the latest version. You can find more information here.
upgrade with discount

A Bootstrap stepper is a component that displays content as a process with defined by user milestones. Following steps are separated and connected by buttons.

This is a great solution for a variety of registration forms, where you don't want to scare the user with loads of fields and questions.

Stepper can be aligned vertically as well as horizontally.

Examples of Bootstrap steps use:

  • Registration form
  • Payment gateway
  • Tutorial with steps

To start working with Dynamic Steppers see the "Getting Started" tab on this page.

All the steppers labeled as MDB Pro component require a simple, additional setup. Have a look at "Getting Started" tab on this page or follow our video tutorial .


How it works

When you are using our basic steppers you will need to copy and paste HTML code to your HTML file and you will have a static horizontal or vertical stepper.

If you want to use our PRO version of steppers you have to load JavaScript code and CSS styles. We have 2 types of files like minified and unminified.

The CSS code for steppers is located in css/addons-pro. The JavaScript code of steppers is located in js/addons-pro.

Paths and initialization code are below:

        
            

        <!-- Stepper CSS -->
        <link href="css/addons-pro/steppers.css" rel="stylesheet">
        <!-- Stepper CSS - minified-->
        <link href="css/addons-pro/steppers.min.css" rel="stylesheet">

        <!-- Stepper JavaScript -->
        <script type="text/javascript" src="js/addons-pro/steppers.js"></script>
        <!-- Stepper JavaScript - minified -->
        <script type="text/javascript" src="js/addons-pro/steppers.min.js"></script>
      
        
    
        
            

        $(document).ready(function () {
          $('.stepper').mdbStepper();
        })

      
        
    

Basic horizontal steppers

You can automatically initialize the stepper component using .stepper and .stepper-horizontal classes.

        
            

        <!-- Horizontal Steppers -->
        <div class="row">
          <div class="col-md-12">

            <!-- Stepers Wrapper -->
            <ul class="stepper stepper-horizontal">

              <!-- First Step -->
              <li class="completed">
                <a href="#!">
                  <span class="circle">1</span>
                  <span class="label">First step</span>
                </a>
              </li>

              <!-- Second Step -->
              <li class="active">
                <a href="#!">
                  <span class="circle">2</span>
                  <span class="label">Second step</span>
                </a>
              </li>

              <!-- Third Step -->
              <li class="warning">
                <a href="#!">
                  <span class="circle"><i class="fas fa-exclamation"></i></span>
                  <span class="label">Third step</span>
                </a>
              </li>

            </ul>
            <!-- /.Stepers Wrapper -->

          </div>
        </div>
        <!-- /.Horizontal Steppers -->
      
        
    

Basic vertical steppers

Add .stepper-vertical class to use the vertical view.

  • 1 First step
  • 2 Second step

    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente.

    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolore error excepturi veniam nemo repellendus, distinctio soluta vitae at sit saepe. Optio eaque quia excepturi adipisci pariatur totam, atque odit fugiat.

    Deserunt voluptatem illum quae nisi soluta eum perferendis nesciunt asperiores tempore saepe reiciendis, vero quod a dolor corporis natus qui magni quas fuga rem excepturi laboriosam. Quisquam expedita ab fugiat.

  • Third step
  • 4 Fourth step
        
            


        <!-- Vertical Steppers -->
        <div class="row mt-1">
          <div class="col-md-12">

            <!-- Stepers Wrapper -->
            <ul class="stepper stepper-vertical">

              <!-- First Step -->
              <li class="completed">
                <a href="#!">
                  <span class="circle">1</span>
                  <span class="label">First step</span>
                </a>
              </li>

              <!-- Second Step -->
              <li class="active">

                <!--Section Title -->
                <a href="#!">
                  <span class="circle">2</span>
                  <span class="label">Second step</span>
                </a>

                <!-- Section Description -->
                <div class="step-content grey lighten-3">
                  <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere
                    iusto
                    quaerat
                    vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore
                    nostrum
                    ut,
                    nobis porro sapiente.</p>
                  <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolore error excepturi veniam nemo
                    repellendus, distinctio soluta vitae at sit saepe. Optio eaque quia excepturi adipisci pariatur
                    totam,
                    atque odit fugiat.</p>
                  <p>Deserunt voluptatem illum quae nisi soluta eum perferendis nesciunt asperiores tempore saepe
                    reiciendis,
                    vero quod a dolor corporis natus qui magni quas fuga rem excepturi laboriosam. Quisquam
                    expedita ab
                    fugiat.</p>
                </div>
              </li>

              <!-- Third Step -->
              <li class="warning">
                <a href="#!">
                  <span class="circle"><i class="fas fa-exclamation"></i></span>
                  <span class="label">Third step</span>
                </a>
              </li>

              <!-- Fourth Step -->
              <li>
                <a href="#!">
                  <span class="circle">4</span>
                  <span class="label">Fourth step</span>
                </a>
              </li>

            </ul>
            <!-- /.Stepers Wrapper -->

          </div>
        </div>

        <!-- Steppers Navigation -->
        <div class="row mt-1">
          <div class="col-md-12 text-right">
            <button class="btn btn-flat btn-sm">Cancel</button>
            <button class="btn btn-primary btn-sm">Next</button>
          </div>
        </div>
        <!-- /.Vertical Steppers -->

      
        
    

Linear Stepper MDB Pro component

A Linear stepper is a component which is very commonly used.

When you are working with this stepper you have to put correct values to do more steps.

We are using Validate jQuery Plugin, so every step will be analysed to ensure compatibility with entered data.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <ul class="stepper linear">
          <li class="step active">
            <div data-step-label="Type something" class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-linear" type="email" class="form-control validate" required>
                  <label for="email-linear">Your e-mail</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-linear" type="password" class="form-control validate" required>
                  <label for="password-linear">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
                <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>

      
        
    
        
            

        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })
      
        
    

Non-linear Stepper MDB Pro component

With a Non-linear stepper you can navigate freely between every step. That said, if you want check validation you have to use buttons to do that.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <ul class="stepper">
          <li class="step active">
            <div data-step-label="Just add a data-step-label!" class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-non" type="email" class="form-control validate" required>
                  <label for="email-non" class="ml-auto">Your e-mail</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-non" type="password" class="form-control validate" required>
                  <label for="password-non">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
                <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>


      
        
    
        
            
        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })
      
        
    

Parallel Stepper MDB Pro component

A Parallel stepper is a combination of linear and non-linear steppers. You can freely navigate between every step and also every step will be checked by custom validation and as well as regular validation entered data with a plugin.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <ul class="stepper parallel">
          <li class="step active">
            <div data-step-label="Just add a data-step-label!" class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-parallel" name="email" type="email" class="form-control validate" required>
                  <label for="email-parallel">Your e-mail</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-parallel" type="password" class="form-control validate" required>
                  <label for="password-parallel">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn-sm btn btn-primary next-step">CONTINUE</button>
                <button class="waves-effect waves-dark btn-sm btn btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn-sm  btn btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>
      
        
    
        
            
        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })
      
        
    

Horizontal Stepper MDB Pro component

A Horizontal stepper is a stepper with a horizontal orientation. If you want use it you need to add class horizontal to your main ul.

Horizontal steppers are fully responsive. When the size of the resolution is smaller than 992px, a horizontal stepper is changed to a vertical stepper.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <ul class="stepper horizontal" id="horizontal-stepper">
          <li class="step active">
            <div class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-horizontal" type="email" class="validate form-control" required>
                  <label for="email-horizontal">Email</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="someFunction21">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-horizontal" type="password" class="validate form-control" required>
                  <label for="password-horizontal">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="someFunction21">CONTINUE</button>
                <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn-sm btn btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>

      
        
    
        
            
        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })

        function someFunction21() {
        setTimeout(function () {
        $('#horizontal-stepper').nextStep();
        }, 2000);
        }
      
        
    

Feedback Step MDB Pro component

If you want, for example, to check if an e-mail exists in your DB, you can define a feedback function with a data-feedback attribute in your next button.

When the user tries to move forward, a loading screen will overlay the active step until you trigger .nextStep manually.

Also if you want to have validation you have to add data-feedback code to your button; you can use either JS code to your script tag or a JS file:

        
            

        <div class="step-actions">
          <button class="btn btn-primary next-step" data-feedback="someFunction">CONTINUE</button>
        </div>
      
        
    
        
            

        function someFunction() {
          setTimeout(function () {
            $('#id-your-stepper').nextStep();
          }, 2000);
        }

      
        
    
  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <ul class="stepper" id="feedback-step">
          <li class="step active">
            <div data-step-label="It's just a second..." class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-feedback" type="email" class="validate form-control" required>
                  <label for="email-feedback">Your e-mail</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="someFunction">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-feedback" type="password" class="form-control validate" required>
                  <label for="password-feedback">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="someFunction">CONTINUE</button>
                <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>

      
        
    
        
            

        function someFunction() {
          setTimeout(function () {
            $('#feedback-step').nextStep();
          }, 2000);
        }

        $(document).ready(function () {
          $('.stepper').mdbStepper();
        })


      
        
    

Validation Step MDB Pro component

This function is mainly focused when using the Parallel Stepper. After checking the previous steps, you may add your own custom validation if jQuery validation is not enough.

After adding the HTML tag data-validator, the given function will be executed and it is expected to return a logical value. If the value is not a boolean value, unexpected behavior will most likely occur.

Tip: If you plan to use both custom validation and feedback, use the custom validation feature to validate and the feedback function to trigger the next step's behavior.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <ul class="stepper parallel" id="custom-validation">
          <li class="step active">
            <div class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-validation" type="email" class="validate form-control" placeholder="This field is not required">
                  <label for="email-validation">Your e-mail</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="validationFunction">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-validation" type="password" class="validate form-control" required>
                  <label for="password-validation">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="validationFunction">CONTINUE</button>
                <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>

      
        
    
        
            

        function validationFunction() {
        setTimeout(function () {
        $('#custom-validation').nextStep();
        }, 1600);
        }
        function someTrueFunction() {
        return true;
        }

        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })


      
        
    

Stepper with shadow MDB Pro component

Stepper can also be used with shadow to add depth to an element on a page.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            

        <div class="z-depth-1 m-2">
          <div class="p-4">
            <ul class="stepper linear">
              <li class="step active">
                <div data-step-label="Type something" class="step-title waves-effect waves-dark">Step 1</div>
                <div class="step-new-content">
                  <div class="row">
                    <div class="md-form col-12 ml-auto">
                      <input id="email-linear" type="email" class="form-control validate" required>
                      <label for="email-linear">Your e-mail</label>
                    </div>
                  </div>
                  <div class="step-actions">
                    <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
                  </div>
                </div>
              </li>
              <li class="step">
                <div class="step-title waves-effect waves-dark">Step 2</div>
                <div class="step-new-content">
                  <div class="row">
                    <div class="md-form col-12 ml-auto">
                      <input id="password-linear" type="password" class="form-control validate" required>
                      <label for="password-linear">Your password</label>
                    </div>
                  </div>
                  <div class="step-actions">
                    <button class="waves-effect waves-dark btn btn-sm btn-primary next-step">CONTINUE</button>
                    <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
                  </div>
                </div>
              </li>
              <li class="step">
                <div class="step-title waves-effect waves-dark">Step 3</div>
                <div class="step-new-content">
                  Finish!
                  <div class="step-actions">
                    <button class="waves-effect waves-dark btn btn-sm btn-primary m-0 mt-4" type="button">SUBMIT</button>
                  </div>
                </div>
              </li>
            </ul>
          </div>
        </div>
      
        
    
        
            

        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })
      
        
    

Horizontal Stepper with a long content MDB Pro component

If you would like to have long content in your horizontal stepper you have to add the new class horizontal-fix to your stepper.

  • Step 1
    Card image cap

    Card title

    Some quick example text to build on the card title and make up the bulk of the card's content.

    Button
  • Step 2
  • Step 3
    Finish!
        
            
 
        <ul class="stepper horizontal horizontal-fix" id="horizontal-stepper-fix">
          <li class="step active">
            <div class="step-title waves-effect waves-dark">Step 1</div>
            <div class="step-new-content">
              <div class="row">
                <!-- Card -->
                <div class="card m-3">

                  <!-- Card image -->
                  <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/43.webp" alt="Card image cap">

                  <!-- Card content -->
                  <div class="card-body">

                    <!-- Title -->
                    <h4 class="card-title"><a>Card title</a></h4>
                    <!-- Text -->
                    <p class="card-text">Some quick example text to build on the card title and make up the bulk of the
                      card's content.</p>
                    <!-- Button -->
                    <a href="#" class="btn btn-primary">Button</a>

                  </div>

                </div>
                <!-- Card -->
                <!-- Card -->
                <div class="card m-3">

                  <!-- Card image -->
                  <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/43.webp" alt="Card image cap">

                  <!-- Card content -->
                  <div class="card-body">

                    <!-- Title -->
                    <h4 class="card-title"><a>Card title</a></h4>
                    <!-- Text -->
                    <p class="card-text">Some quick example text to build on the card title and make up the bulk of the
                      card's content.</p>0
                    <!-- Button -->
                    <a href="#" class="btn btn-primary">Button</a>

                  </div>

                </div>
                <!-- Card -->
              </div>
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="email-horizontal-fix" type="email" class="validate form-control" required>
                  <label for="email-horizontal-fix">Email</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="someFunction22">CONTINUE</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 2</div>
            <div class="step-new-content">
              <div class="row">
                <div class="md-form col-12 ml-auto">
                  <input id="password-horizontal-fix" type="password" class="validate form-control" required>
                  <label for="password-horizontal-fix">Your password</label>
                </div>
              </div>
              <div class="step-actions">
                <button class="waves-effect waves-dark btn btn-sm btn-primary next-step" data-feedback="someFunction22">CONTINUE</button>
                <button class="waves-effect waves-dark btn btn-sm btn-secondary previous-step">BACK</button>
              </div>
            </div>
          </li>
          <li class="step">
            <div class="step-title waves-effect waves-dark">Step 3</div>
            <div class="step-new-content">
              Finish!
              <div class="step-actions">
                <button class="waves-effect waves-dark btn-sm btn btn-primary m-0 mt-4" type="button">SUBMIT</button>
              </div>
            </div>
          </li>
        </ul>

      
        
    
        
            
        ul.horizontal-fix li a {
        padding: .84rem 2.14rem;
        }
      
        
    
        
            
        $(document).ready(function () {
        $('.stepper').mdbStepper();
        })

        function someFunction22() {
        setTimeout(function () {
        $('#horizontal-stepper-fix').nextStep();
        }, 2000);
        }

Vue Bootstrap Stepper

Vue Stepper - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Vue Bootstrap stepper is a component that displays content as a process with defined by user milestones. Following steps are separated and connected by buttons.

This is a great solution for a variety of registration forms, where you don't want to scare the user with loads of fields and questions.

All Steppers (apart from within version) can be aligned vertically as well as horizontally.

Vue live preview Vue live preview (PRO)

Simple Vertical Stepper

In the MDB Vue Free Package stepper has value of SimpleV the property set to true by default, although it is still recommended to add this property to avoid code changes in case of an upgrade.

        
            
        <template>
            <mdb-stepper simpleV :steps="verticalStepper" v-model="currentStep"/>
        </template>
      
        
    
        
            
        <script>
          import { mdbStepper } from 'mdbvue';
          export default {
            components: {
              mdbStepper,
            },
            data() {
              return {
                currentStep: 2,
                verticalStepper: [
                  {
                    content:
                      "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente."
                  },
                  {
                    content:
                      "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente."
                  },
                  {
                    content:
                      "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente."
                  }
                ],
              };
            }
          };
        </script>
    
        
    

Simple Horizontal Stepper

To change Stepper's orientation to horizontal, add SimpleH property.

        
            
        <template>
            <mdb-stepper simpleH :steps="steps"/>
        </template>
      
        
    
        
            
        <script>
          import { mdbStepper } from 'mdbvue';
          export default {
            components: {
              mdbStepper,
            },
            data() {
              return {
                steps: [
                  {
                    content:
                      "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente."
                  },
                  {
                    content:
                      "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente."
                  },
                  {
                    content:
                      "Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente."
                  }
                ],
              };
            }
          };
        </script>
    
        
    

Simple Vertical Stepper MDB Pro component

In MDB Vue Pro version in order to use Simple vertical stepper, set SimpleV property to true. You can customize your stepper further - to view the list of all available props and events, visit the API tab.

        
            
        <template>
          <mdb-stepper simpleV :steps="4">
            <template #1>
              <form>
                <mdb-input label="name"/>
              </form>
            </template>
            <template #2>
              <form>
                <mdb-input label="email" type="email"/>
              </form>
            </template>
            <template #3>
              <form>
                <mdb-input label="message" type="textarea" :rows="4"/>
              </form>
            </template>
              <template #4>
              <p>Finish!</p>
            </template>
          </mdb-stepper>
      </template>
      
        
    
        
            
        <script>
          import { mdbStepper, mdbInput } from 'mdbvue';
          export default {
            components: {
              mdbStepper, mdbInput
            }
          };
        </script>
    
        
    

Simple Vertical Stepper - Buttons MDB Pro component

To display Next/Previous/Submit buttons, set property buttons to true

        
            
        <template>
          <mdb-stepper simpleV :steps="4" buttons>
            <template #1>
              <form>
                <mdb-input label="name"/>
              </form>
            </template>
            <template #2>
              <form>
                <mdb-input label="email" type="email"/>
              </form>
            </template>
            <template #3>
              <form>
                <mdb-input label="message" type="textarea" :rows="4"/>
              </form>
            </template>
              <template #4>
              <p>Finish!</p>
            </template>
          </mdb-stepper>
      </template>
      
        
    
        
            
        <script>
          import { mdbStepper, mdbInput } from 'mdbvue';
          export default {
            components: {
              mdbStepper,
              mdbInput
            }
          };
        </script>
    
        
    

Simple Vertical Stepper - Linear MDB Pro component

To prevent the user from going more than one step ahead, add the prop linear to your stepper.

        
            
        <template>
          <mdb-stepper simpleV :steps="4" linear>
            <template #1>
              <form>
                <mdb-input label="name"/>
              </form>
            </template>
            <template #2>
              <form>
                <mdb-input label="email" type="email"/>
              </form>
            </template>
            <template #3>
              <form>
                <mdb-input label="message" type="textarea" :rows="4"/>
              </form>
            </template>
              <template #4>
              <p>Finish!</p>
            </template>
          </mdb-stepper>
      </template>
      
        
    
        
            
        <script>
          import { mdbStepper, mdbInput } from 'mdbvue';
          export default {
            components: {
              mdbStepper,
              mdbInput
            }
          };
        </script>
    
        
    

Simple Vertical Stepper - Validation MDB Pro component

In order to validate a step before allowing user to go to the next one, add the following properties to your stepper: validation and validatedSteps. User will be able to access only steps which corresponding keys in the validatedSteps object have the value set to true. Every time user attempts to change a step, @validate event will be emitted - it's handler should evaluate the current step and change its value in the validatedSteps prop.

        
            
      <template>
        <mdb-stepper
          simpleV
          :steps="3"
          buttons
          validation
          :validatedSteps="validatedSteps"
          @validate="validate"
          @submit="submit"
        >
          <template #1>
            <form ref="vertical1">
              <mdb-input label="name" v-model="name" required />
            </form>
          </template>
          <template #2>
            <form ref="vertical2">
              <mdb-input label="surname" v-model="surname" required />
            </form>
          </template>
          <template #3>
            <p>Finish!</p>
          </template>
        </mdb-stepper>
      </template>
      
        
    
        
            
        <script>
          import {
            mdbStepper,
            mdbInput
          } from "mdbvue";

          export default {
            components: {
              mdbStepper,
              mdbInput
            },
            data() {
              return {
                name: "",
                surname: "",
                validatedSteps: {}
              };
            },
            methods: {
              validate(step) {
                this.$refs[`vertical${step}`].classList.add("was-validated");

                if (step === 1 && this.name.length > 0)

                  this.validatedSteps[1] = true;

                else if (step === 2 && this.surname.length > 0)
                  this.validatedSteps[2] = true;
              },
              submit() {
                console.log(`${this.name} has submitted the form.s`);
              }
            }
          };
        </script>
    
        
    

Simple Horizontal Stepper MDB Pro component

To change Stepper's orientation to vertical, add SimpleV property.

        
            
      <template>
        <mdb-stepper simpleH :steps="4">
          <template #1>
            <form>
              <mdb-input label="name"/>
            </form>
          </template>
          <template #2>
            <form>
              <mdb-input label="email" type="email"/>
            </form>
          </template>
          <template #3>
            <form>
              <mdb-input label="message" type="textarea" :rows="4"/>
            </form>
          </template>
            <template #4>
            <p>Finish!</p>
          </template>
        </mdb-stepper>
      </template>
      
        
    
        
            
        <script>
          import { mdbStepper, mdbInput } from 'mdbvue';
          export default {
            components: {
              mdbStepper,
              mdbInput
            }
          };
        </script>
    
        
    

Horizontal Stepper MDB Pro component

To display icons in step buttons, pass an array to the steps property and specify an icon for each step.

        
            
        <template>
          <mdb-stepper buttons :steps="registrationStepper" @submit="submit">
            <template #1>
              <h3 class="font-weight-bold pl-0 my-4">
                <strong>Basic Information</strong>
              </h3>
              <mdb-input label="Email" />
              <mdb-input label="Username" />
              <mdb-input label="Password" />
              <mdb-input label="Repeat Password" />
            </template>
            <template #2>
              <h3 class="font-weight-bold pl-0 my-4">
                <strong>Personal Data</strong>
              </h3>
              <mdb-input label="First Name" />
              <mdb-input label="Second Name" />
              <mdb-input label="Surname" />
              <mdb-input type="textarea" label="Address" />
            </template>
            <template #3>
              <h3 class="font-weight-bold pl-0 m-4">
                <strong>Terms and conditions</strong>
              </h3>
              <mdb-input
                type="checkbox"
                id="checkbox1"
                label="I agree to the terms and conditions"
              />
              <mdb-input
                class="mb-5"
                type="checkbox"
                id="checkbox2"
                label="I want to receive newsletter"
              />
            </template>
            <template #4>
              <h3 class="font-weight-bold pl-0 my-4">
                <strong>Finish</strong>
              </h3>
              <h2 class="text-center font-weight-bold my-4">Registration completed!</h2>
            </template>
          </mdb-stepper>
        </template>
      
        
    
        
            
        <script>
          import {
            mdbStepper,
            mdbInput
          } from "mdbvue";

          export default {
            components: {
              mdbStepper,
              mdbInput,
            },
            data() {
              return {
                registrationStep: 2,
                registrationStepper: [
                  { icon: "folder", far: true, name: "Basic Information" },
                  { icon: "pencil-alt", name: "Personal Data" },
                  { icon: "image", far: true, name: "Terms and Conditions" },
                  { icon: "check", name: "Finish" }
                ],
              }
            },
            methods: {
              submit() {
                console.log('submitted');
              }
            }
          };
        </script>
    
        
    

Horizontal Stepper - color variations MDB Pro component

You can control the stepper's appearance with options property. Visit the API tab to explore all available settings.

        
            
        <template>
          <mdb-stepper buttons :steps="registrationStepper" @submit="submit" :options="options">
            <template #1>
              <h3 class="font-weight-bold pl-0 my-4">
                <strong>Basic Information</strong>
              </h3>
              <mdb-input label="Email" />
              <mdb-input label="Username" />
              <mdb-input label="Password" />
              <mdb-input label="Repeat Password" />
            </template>
            <template #2>
              <h3 class="font-weight-bold pl-0 my-4">
                <strong>Personal Data</strong>
              </h3>
              <mdb-input label="First Name" />
              <mdb-input label="Second Name" />
              <mdb-input label="Surname" />
              <mdb-input type="textarea" label="Address" />
            </template>
            <template #3>
              <h3 class="font-weight-bold pl-0 m-4">
                <strong>Terms and conditions</strong>
              </h3>
              <mdb-input
                type="checkbox"
                id="checkbox1"
                label="I agree to the terms and conditions"
              />
              <mdb-input
                class="mb-5"
                type="checkbox"
                id="checkbox2"
                label="I want to receive newsletter"
              />
            </template>
            <template #4>
              <h3 class="font-weight-bold pl-0 my-4">
                <strong>Finish</strong>
              </h3>
              <h2 class="text-center font-weight-bold my-4">Registration completed!</h2>
            </template>
          </mdb-stepper>
        </template>
      
        
    
        
            
        <script>
          import {
            mdbStepper,
            mdbInput
          } from "mdbvue";

          export default {
            components: {
              mdbStepper,
              mdbInput,
            },
            data() {
              return {
                registrationStep: 2,
                registrationStepper: [
                  { icon: "folder", far: true, name: "Basic Information" },
                  { icon: "pencil-alt", name: "Personal Data" },
                  { icon: "image", far: true, name: "Terms and Conditions" },
                  { icon: "check", name: "Finish" }
                ],
                options: {
                  stepBtn: { color: "info", active: "amber", iconClass: "white-text" },
                  nextBtn: { outline: "info", icon: "chevron-right" },
                  prevBtn: { outline: "info", icon: "chevron-left" },
                  submitBtn: { color: "amber", icon: "check" },
                  lineColor: "amber"
                },
              }
            },
            methods: {
              submit() {
                console.log('submitted');
              }
            }
          };
        </script>
    
        
    

Horizontal Stepper - validation MDB Pro component

        
            
        <template>
          <mdb-stepper
            class="pt-5"
            buttons
            validation
            :validatedSteps="validatedSteps"
            @validate="validate"
            @submit="submit"
            :steps="validationStepper"
            :options="validationOptions"
          >
            <template #1>
              <h3 class="font-weight-bold pt-3 pl-0 my-4">
                <h2>Personal Information</h2>
              </h3>
              <form ref="form1">
                <mdb-input required label="First Name" v-model="form[0].name" />
                <mdb-input required label="Second Name" v-model="form[0].surname" />
                <mdb-input required label="Address" v-model="form[0].address" />
              </form>
            </template>
            <template #2>
              <h3 class="font-weight-bold pt-3 pl-0 my-4">
                <h2>Company Information</h2>
              </h3>
              <form ref="form2">
                <mdb-input required label="Company Name" v-model="form[1].company" />
                <mdb-input required label="Company Address" v-model="form[1].address" />
              </form>
            </template>
            <template #3>
              <h3 class="font-weight-bold pt-3 pl-0 my-4">
                <h2>Terms and conditions</h2>
              </h3>
              <form ref="form3">
                <mdb-input
                  type="checkbox"
                  id="checkbox3"
                  required
                  v-model="form[2].condition"
                  label="I agree to the terms and conditions"
                />
                <mdb-input type="checkbox" id="checkbox4" label="I want to receive newsletter" />
              </form>
            </template>
          </mdb-stepper>
        </template>
      
        
    
        
            
        <script>
          import {
            mdbStepper,
            mdbInput,
          } from "mdbvue";

          export default {
            components: {
              mdbStepper,
              mdbInput,
            },
            data() {
              return {
                validationStepper: [
                  { icon: "folder", far: true, name: "Basic Information" },
                  { icon: "pencil-alt", name: "Company" },
                  { icon: "check", name: "Finish" }
                ],
                validationOptions: {
                  stepBtn: {
                    outline: "pink",
                    active: "pink",
                    iconClass: "pink-text"
                  },
                  nextBtn: {
                    outline: "pink"
                  },
                  prevBtn: {
                    outline: "pink"
                  },
                  submitBtn: {
                    color: "success"
                  },
                  lineColor: "pink"
                },
                validatedSteps: {},
                form: [
                  {
                    name: "",
                    surname: "",
                    address: ""
                  },
                  {
                    company: "",
                    address: ""
                  },
                  {
                    condition: false
                  }
                ],
              }
            },
            methods: {
              checkForm(form) {
                return (
                  Object.keys(form).length ===
                  Object.keys(form).filter(key => form[key].length > 0).length
                );
              },
              validate(step) {
                this.$refs[`form${step}`].classList.add("was-validated");

                if (step === 3) {
                  this.validatedSteps[step] = this.form[step - 1].condition;
                } else if (this.checkForm(this.form[step - 1])) {
                  this.validatedSteps[step] = true;
                } else {
                  this.validatedSteps[step] = false;
                }
              },
              submit() {
                this.validate(3);
                if (this.validatedSteps[3]) {
                  console.log("submited!");
                }
              },
            }
          };
        </script>
    
        
    

Vertical Stepper MDB Pro component

To change stepper's orientation to vertical, set vertical property to true

        
            
        <template>
            <mdb-stepper vertical buttons :steps="registrationStepper" :options="options">
              <template #1>
                <h3 class="font-weight-bold pl-0 my-4">
                  <strong>Basic Information</strong>
                </h3>
                <mdb-input label="Email" />
                <mdb-input label="Username" />
                <mdb-input label="Password" />
                <mdb-input label="Repeat Password" />
              </template>
              <template #2>
                <h3 class="font-weight-bold pl-0 my-4">
                  <strong>Personal Data</strong>
                </h3>
                <mdb-input label="First Name" />
                <mdb-input label="Second Name" />
                <mdb-input label="Surname" />
                <mdb-input type="textarea" label="Address" />
              </template>
              <template #3>
                <h3 class="font-weight-bold pl-0 my-4">
                  <strong>Terms and conditions</strong>
                </h3>
                <mdb-input
                  type="checkbox"
                  id="checkbox1"
                  label="I agree to the terms and conditions"
                />
                <mdb-input type="checkbox" id="checkbox2" label="I want to receive newsletter" />
              </template>
              <template #4>
                <h3 class="font-weight-bold pl-0 my-4">
                  <strong>Finish</strong>
                </h3>
                <h2 class="text-center font-weight-bold my-4">Registration completed!</h2>
              </template>
            </mdb-stepper>
        </template>
      
        
    
        
            
        <script>
          import {
            mdbStepper,
            mdbInput
          } from "mdbvue";

          export default {
            components: {
              mdbStepper,
              mdbInput,
            },
            data() {
              return {
                registrationStepper: [
                  { icon: "folder", far: true, name: "Basic Information" },
                  { icon: "pencil-alt", name: "Personal Data" },
                  { icon: "image", far: true, name: "Terms and Conditions" },
                  { icon: "check", name: "Finish" }
                ],
                options: {
                  stepBtn: { color: "info", active: "amber", iconClass: "white-text" },
                  nextBtn: { outline: "info", icon: "chevron-right" },
                  prevBtn: { outline: "info", icon: "chevron-left" },
                  submitBtn: { color: "amber", icon: "check" },
                  lineColor: "amber"
                },
              }
            },
            methods: {
              submit() {
                console.log('submitted');
              }
            }
          };
        </script>
    
        
    

Stepper within form MDB Pro component

        
            
        <template>
          <mdb-card class="m-5 p-5">
            <mdb-card-body>
              <h2 class="text-center font-weight-bold pt-4 pb-5">
                <strong>Steps form example</strong>
              </h2>
              <mdb-stepper within buttons :steps="3">
                <template #1>
                  <h3 class="font-weight-bold pl-0 my-4">
                    <strong>Step 1</strong>
                  </h3>
                  <mdb-input label="First Name" />
                  <mdb-input label="Second Name" />
                  <mdb-input type="textarea" label="Address" />
                </template>
                <template #2>
                  <h3 class="font-weight-bold pl-0 my-4">
                    <strong>Step 2</strong>
                  </h3>
                  <mdb-input label="Company Name" />
                  <mdb-input label="Company Addresws" />
                  <mdb-input type="textarea" label="Address" />
                </template>
                <template #3>
                  <h3 class="font-weight-bold pl-0 my-4">
                    <strong>Step 3</strong>
                  </h3>
                </template>
              </mdb-stepper>
            </mdb-card-body>
          </mdb-card>
        </template>
      
        
    
        
            
        <script>
          import {
            mdbStepper,
            mdbInput,
            mdbCard,
            mdbCardBody
          } from "mdbvue";

          export default {
            components: {
              mdbStepper,
              mdbInput,
              mdbCard,
              mdbCardBody
            }
          };
        </script>
    
        
    

Vue Stepper - API

In this section you will find advanced information about the Stepper component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use in working with it.


Import statement

        
            
      <script>
        import { mdbStepper } from 'mdbvue';
      </script>
    
        
    

Simple Stepper

The simple mdbStepper is available in two versions - horizontal and vertical.


API Reference: Properties

Name Type Default Description Example
simpleH Boolean true Changes the stepper's layout to the horizontal version <mdb-stepper simpleH />
simpleV Boolean false Changes the stepper's layout to simple, vertical version. <mdb-stepper simpleV />
steps (required) Array, Number false Controlls the number of steps - see required data structure for rendering content below <mdb-stepper :steps="steps" />

API Reference: Directives and methods

Name Description Example
v-model Allows to change active step from the outside. <mdb-stepper v-model="step" />
@input Emits current step's index (starts at 1) <mdb-stepper @input="showIndex" />

Data structure

        
            
          const steps = [
            { name, content },
            { name, content },
            ... ,
            { name, content }
          ];
      
        
    

The value of content will be rendered for each step separately and shown when the given step is active. The name will replace the default step's title (f.e. "Step 1") with the given value.


Stepper PRO - introduction MDB Pro component

The PRO version of the mdbStepper stepper component is much more advanced - it offers many customization options and layout versions.

Rendering content

The mdbStepper has one required property - steps with two accepted datatypes: Array and Number. Based on this value component will calculate the number of steps and neccessary slots. Each slot is named by according to its order (starting at 1), f.e: #1 / v-slot:1.

        
            
      <template>
        <mdb-stepper :step="2">
          <template v-slot:1>
            <div>
              <h2>First slot!</h2>
              <p>Content</p>
            </div>
          </template>
          <template v-slot:2>
            <div>
              <h2>Second slot!</h2>
              <p>Content</p>
            </div>
          </template>
        </mdb-stepper>
      </template>
    
        
    

Remember that v-slot directive can be used only on the template element.

v-slot:1 can be used interchangeably with #1 syntax.


Default Stepper

Although the only prop required for default mdbStepper to work is steps property, this component can be customized in multiple ways. Below we have listed all available options.


API Reference: Properties

Name Type Default Description Example
steps (required) Array, Number - Determines number of steps and allows to set an icon for each step. See the data structure below. <mdb-stepper :steps="steps" />
buttons Boolean false When set to true it will add next, previous and submit buttons to your stepper. Button can be customized by options prop. <mdb-stepper buttons :steps="4" />
disabled Boolean false Disables all buttons in a stepper <mdb-stepper disabled />
options Object see default settings below Allows to customize buttons and a horizontal line's color. All available options are listed below. <mdb-stepper :steps="steps" button :options="options." />
linear Boolean false Prevents user from jumping further than one step ahead <mdb-stepper :steps="steps" linear />
verical Boolean false Changes orientation of the stepper to vertical <mdb-stepper :steps="steps" vertical />
validation Boolean false Activates validation. User won't be able to access steps which are not set to true in validatedSteps object <mdb-stepper :steps="steps" validation :validatedSteps="validated" />
validatedSteps Object Required for steppers with validation property set to true. Each key corresponds to step's index - if its value is true user will be able to move forward <mdb-stepper :steps="steps" validation :validatedSteps="validated" />

API Reference: Directives and methods

Name Description Example
v-model Allows to change active step from the outside. <mdb-stepper :steps="steps" v-model="step" />
@changeStep Emits current step's index (starts at 1) <mdb-stepper @changeStep="showIndex" />
@submit Emitted when the submit button is clicked <mdb-stepper buttons @submit="submit" />
@validate Emitted when user attempts to change a step to the next in the stepper with validation property. This event allows to review the current step's content and decide if user shoud be allowed to go to the next. Validation should update the value of the validatedSteps property. <mdb-stepper validation :validatedSteps="validated" @validate="validate" />

Data structure

Steps

        
            
          const step = { 
            name: "String", 
            icon: "String", 
            far: "Boolean", 
            fab: "Boolean", 
            fal: "Boolean", 
            fad: "Boolean"
          };
        
        
    
        
            
          const steps = [ 
            { 
              name: "Basic information", 
              icon: "paper-plane", 
              far: true
            }, 
            { 
              name: "Send", 
              icon: "user" 
            } 
          ];
        
        
    

Options

        
            
          const options = { 
            stepBtn: { 
              active: "String - background color for a button representing an active step", 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              iconClass: "String - changes color of the step icon" 
            }, 
            nextBtn: { 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              icon: "String", 
              text: "String", 
              far: "Boolean", 
              fal: "Boolean", 
              fad: "Boolean",
              fab: "Boolean" 
            }, 
            prevBtn: { 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              icon: "String", 
              text: "String", 
              far: "Boolean", 
              fal: "Boolean", 
              fad: "Boolean", 
              fab: "Boolean" 
            }, 
            prevBtn: { 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              icon: "String", 
              text: "String",
              far: "Boolean",
              fal: "Boolean", 
              fad: "Boolean", 
              fab: "Boolean" 
            }, 
            lineColor: "String", 
            verticalSpacing: "Number - minimum height of the vertical stepper element is calculated based on this number and quantity of steps. (Default: 120)" 
          };
        
        
    
        
            
          const options = {
            stepBtn: { 
              outline: "indigo", 
              active: "indigo", 
              iconClass: "indigo-text"
            }, 
            nextBtn: { 
              color: "indigo", 
              text: "Next" 
            },
            prevBtn: { 
              color: "indigo", 
              text: "Previous" 
            }, 
            submitBtn: {
              color: "success", 
              text: "Submit" 
            }, 
            lineColor: "indigo",
            vericalSpacing: 120
          };
      
        
    

Stepper within

Although the only prop required for default mdbStepper to work is steps property, this component can be customized in multiple ways. Below we have listed all available options.


API Reference: Properties

Name Type Default Description Example
steps (required) Array, Number - Determines number of steps and allows to set an icon for each step. See the data structure below. <mdb-stepper within :steps="steps" />
within Boolean false Changes the stepper's layout to within option <mdb-stepper within :steps="steps" />
buttons Boolean false When set to true it will add next, previous and submit buttons to your stepper. Button can be customized by options prop. <mdb-stepper within buttons :steps="4" />
disabled Boolean false Disables all buttons in a stepper <mdb-stepper disabled />
options Object see default settings below Allows to customize buttons - all available options are listed below. <mdb-stepper within :steps="steps" button :options="options" />
validation Boolean false Activates validation. User won't be able to access steps which are not set to true in validatedSteps object <mdb-stepper within :steps="steps" validation :validatedSteps="validated" />
validatedSteps Object Required for steppers with validation property set to true. Each key corresponds to step's index - if its value is true user will be able to move forward <mdb-stepper within :steps="steps" validation :validatedSteps="validated" />
linear Boolean false Prevents user from jumping further than one step ahead <mdb-stepper within :steps="steps" linear />

API Reference: Directives and methods

Name Description Example
v-model Allows to change active step from the outside. <mdb-stepper :steps="steps" v-model="step" />
@changeStep Emits current step's index (starts at 1) <mdb-stepper @changeStep="showIndex" />
@submit Emitted when the submit button is clicked <mdb-stepper buttons @submit="submit" />
@validate Emitted when user attempts to change a step to the next in the stepper with validation property. This event allows to review the current step's content and decide if user shoud be allowed to go to the next. Validation should update the value of the validatedSteps property. <mdb-stepper validation :validatedSteps="validated" @validate="validate" />

Data structure

Steps

        
            
          const step = { 
            name: "String",
            icon: "String",
            far: "String",
            fab: "String",
            fal: "String",
            fad: "String"
          };
        
        
    
        
            
          const steps = [ 
            { 
              name: "Step 1",
              icon: "paper-plane",
              far: true
            }, 
            { 
              name: "Step 2",
              icon: "map"
            } 
          ];
        
        
    

Options

        
            
          const options = { 
            withinBtn: { 
              active: "String - background color for a button representing an active step", 
              color: "String - background color for all buttons", 
            }, 
            nextBtn: { 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              icon: "String", 
              text: "String", 
              far: "Boolean", 
              fal: "Boolean", 
              fad: "Boolean",
              fab: "Boolean" 
            }, 
            prevBtn: { 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              icon: "String", 
              text: "String", 
              far: "Boolean", 
              fal: "Boolean", 
              fad: "Boolean", 
              fab: "Boolean" 
            }, 
            submitvBtn: { 
              color: "String - background color for all buttons", 
              outline: "String - outline color for all buttons - alternative for the color key", 
              icon: "String", 
              text: "String",
              far: "Boolean",
              fal: "Boolean", 
              fad: "Boolean", 
              fab: "Boolean" 
            } 
          };
          
        
    
        
            
          const options = {
            withinBtn: { 
              color: "default", 
              active: "indigo", 
            }, 
            nextBtn: { 
              color: "indigo", 
              text: "Next" 
            },
            prevBtn: { 
              color: "indigo", 
              text: "Previous" 
            }, 
            submitBtn: {
              color: "success", 
              text: "Submit" 
            }
          };
        
        
    

Simple stepper

In the free version of this stepper, the content is rendered via content key passed to steps property. It will still work in the pro version, but for more complicated steppers we recommend using template elements with the v-slot directive.


API Reference: Properties

Name Type Default Description Example
steps (required) Array, Number - Determines number of steps and allows to set an icon for each step. See the data structure below. <mdb-stepper within :steps="steps" />
simpleV Boolean false Changes the stepper's layout to simple vertical varsion <mdb-stepper simpleV :steps="4" />
simpleH Boolean false Changes the stepper's layout to simple horizontal varsion <mdb-stepper simpleH :steps="4" />
buttons Boolean false When set to true it will add next, previous and submit buttons to your stepper. Button can be customized by options prop. <mdb-stepper within buttons :steps="4" />
disabled Boolean false Disables all buttons in a stepper <mdb-stepper disabled />
options Object see default settings below Allows to customize buttons - all available options are listed below. <mdb-stepper within :steps="steps" button :options="options" />
validation Boolean false Activates validation. User won't be able to access steps which are not set to true in validatedSteps object <mdb-stepper within :steps="steps" validation :validatedSteps="validated" />
validatedSteps Object Required for steppers with validation property set to true. Each key corresponds to step's index - if its value is true user will be able to move forward <mdb-stepper within :steps="steps" validation :validatedSteps="validated" />
linear Boolean false Prevents user from jumping further than one step ahead <mdb-stepper within :steps="steps" linear />

API Reference: Directives and methods

Name Description Example
v-model Allows to change active step from the outside. <mdb-stepper :steps="steps" v-model="step" />
@changeStep Emits current step's index (starts at 1) <mdb-stepper @changeStep="showIndex" />
@submit Emitted when the submit button is clicked <mdb-stepper buttons @submit="submit" />
@validate Emitted when user attempts to change a step to the next in the stepper with validation property. This event allows to review the current step's content and decide if user shoud be allowed to go to the next. Validation should update the value of the validatedSteps property. <mdb-stepper validation :validatedSteps="validated" @validate="validate" />

Data structure

Steps

        
            
          const step = {
            name: "String",
            content: "String"
          };
        
        
    
        
            
          const steps = [
            {
              name: "Step 1",
              content: "Optional content"
            },
            {
              name: "Step 2",
            }
          ];
        
        
    

Options

        
            
            const options = {
              stepBtn: {
                color: "String - background color of inactive step buttons"
              },
              nextBtn: {
                color: "String - background color for all buttons",
                text: "String",
              },
              prevBtn: {
                color: "String - background color for all buttons",
                text: "String",
              },
              submitBtn: {
                color: "String - background color for all buttons",
                text: "String",
              }
            };
          
        
    
        
            
            nextBtn: {
                color: "indigo",
                text: "Next"
              },
              prevBtn: {
                color: "indigo",
                text: "Previous"
              },
              submitBtn: {
                color: "success",
                text: "Submit"
              }
            };

React Bootstrap Stepper

React Stepper - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React Bootstrap stepper is a component that displays content as a process with defined by user milestones. Following steps are separated and connected by buttons.

This is a great solution for a variety of registration forms, where you don't want to scare the user with loads of fields and questions.

Stepper can be aligned vertically as well as horizontally.

Examples of React Bootstrap steps use:

  • Registration form
  • Payment gateway
  • Tutorial with steps

See the following Bootstrap React stepper examples:


Registration form with steps

The step indicator is generated by the component, basing on the name and icon props passed in with individual steps.

Registration form

Basic Information

Personal Data

Terms and conditions

Finish

Registration completed!

        
            
          import React from "react";
          import {
            MDBContainer,
            MDBRow,
            MDBCol,
            MDBStepper,
            MDBStep,
            MDBBtn,
            MDBInput
          } from "mdbreact";
  
          class StepperExample extends React.Component {
            state = {
              formActivePanel1: 1,
              formActivePanel1Changed: false,
            }
  
            swapFormActive = (a) => (param) => (e) => {
              this.setState({
                ['formActivePanel' + a]: param,
                ['formActivePanel' + a + 'Changed']: true
              });
            }
  
            handleNextPrevClick = (a) => (param) => (e) => {
              this.setState({
                ['formActivePanel' + a]: param,
                ['formActivePanel' + a + 'Changed']: true
              });
            }
  
            handleSubmission = () => {
              alert('Form submitted!');
            }
  
            calculateAutofocus = (a) => {
              if (this.state['formActivePanel' + a + 'Changed']) {
                return true
              }
            }
  
            render() {
              return (
                <MDBContainer>
                  <h2 className="text-center font-weight-bold pt-4 pb-5 mb-2"><strong>Registration form</strong></h2>
                  <MDBStepper icon>
                    <MDBStep far icon="folder-open" stepName="Basic Information" onClick={this.swapFormActive(1)(1)}></MDBStep>
                    <MDBStep icon="pencil-alt" stepName="Personal Data" onClick={this.swapFormActive(1)(2)}></MDBStep>
                    <MDBStep icon="photo" stepName="Terms and Conditions" onClick={this.swapFormActive(1)(3)}></MDBStep>
                    <MDBStep icon="check" stepName="Finish" onClick={this.swapFormActive(1)(4)}></MDBStep>
                  </MDBStepper>
  
                  <form role="form" action="" method="post">
                    <MDBRow>
                      {this.state.formActivePanel1 == 1 &&
                      (<MDBCol md="12">
                        <h3 className="font-weight-bold pl-0 my-4">
                          <strong>Basic Information</strong></h3>
                        <MDBInput label="Email" className="mt-4" autoFocus={this.calculateAutofocus(1)} />
                        <MDBInput label="Username" className="mt-4" />
                        <MDBInput label="Password" className="mt-4" />
                        <MDBInput label="Repeat Password" className="mt-4" />
                        <MDBBtn color="mdb-color" rounded className="float-right" onClick={this.handleNextPrevClick(1)(2)}>next</MDBBtn>
                      </MDBCol>)}
  
                      {this.state.formActivePanel1 == 2 &&
                      (<MDBCol md="12">
                        <h3 className="font-weight-bold pl-0 my-4"><strong>Personal Data</strong></h3>
                        <MDBInput label="First Name" className="mt-3" autoFocus={this.calculateAutofocus(1)} />
                        <MDBInput label="Second Name" className="mt-3" />
                        <MDBInput label="Surname" className="mt-3" />
                        <MDBInput label="Address" type="textarea" rows="2" />
                        <MDBBtn color="mdb-color" rounded className="float-left" onClick={this.handleNextPrevClick(1)(1)}>previous</MDBBtn>
                        <MDBBtn color="mdb-color" rounded className="float-right" onClick={this.handleNextPrevClick(1)(3)}>next</MDBBtn>
                      </MDBCol>)}
  
                      {this.state.formActivePanel1 == 3 &&
                      (<MDBCol md="12">
                        <h3 className="font-weight-bold pl-0 my-4"><strong>Terms and conditions</strong></h3>
                        <MDBInput label="I agreee to the terms and conditions" type="checkbox" id="checkbox" autoFocus={this.calculateAutofocus(1)} />
                        <MDBInput label="I want to receive newsletter" type="checkbox" id="checkbox2" />
                        <MDBBtn color="mdb-color" rounded className="float-left" onClick={this.handleNextPrevClick(1)(2)}>previous</MDBBtn>
                        <MDBBtn color="mdb-color" rounded className="float-right" onClick={this.handleNextPrevClick(1)(4)}>next</MDBBtn>
                      </MDBCol>)}
  
                      {this.state.formActivePanel1 == 4 &&
                      (<MDBCol md="12">
                        <h3 className="font-weight-bold pl-0 my-4"><strong>Finish</strong></h3>
                        <h2 className="text-center font-weight-bold my-4">Registration completed!</h2>
                        <MDBBtn color="mdb-color" rounded className="float-left" onClick={this.handleNextPrevClick(1)(3)}>previous</MDBBtn>
                        <MDBBtn color="success" rounded className="float-right" onClick={this.handleSubmission}>submit</MDBBtn>
                      </MDBCol>)}
                    </MDBRow>
                  </form>
                </MDBContainer>
              );
            };
          }
  
          export default StepperExample;
          
        
    

Vertical registration form steps

Basic Information

Personal Data

Terms and conditions

Finish

Registration completed!

        
            
  
          import React from "react";
          import {
            MDBContainer,
            MDBRow,
            MDBCol,
            MDBStepper,
            MDBStep,
            MDBBtn,
            MDBCard,
            MDBCardBody,
            MDBInput
          } from "mdbreact";
  
          class StepperExample extends React.Component {
            state = {
              formActivePanel3: 1,
              formActivePanel1Changed: false,
            }
  
            swapFormActive = (a) => (param) => (e) => {
              this.setState({
                ['formActivePanel' + a]: param,
                ['formActivePanel' + a + 'Changed']: true
              });
            }
  
            handleNextPrevClick = (a) => (param) => (e) => {
              this.setState({
                ['formActivePanel' + a]: param,
                ['formActivePanel' + a + 'Changed']: true
              });
            }
  
            handleSubmission = () => {
              alert('Form submitted!');
            }
  
            calculateAutofocus = (a) => {
              if (this.state['formActivePanel' + a + 'Changed']) {
              return true
              }
            }
  
            render() {
              return (
                <MDBContainer>
                  <MDBCard>
                    <MDBCardBody>
                      <MDBRow className="pt-5 justify-content-center">
                        <MDBCol md="2" className="pl-5 pl-md-0 pb-5">
                          <MDBStepper icon vertical>
                            <MDBStep far icon="folder-open" stepName="Basic Information" onClick={this.swapFormActive(3)(1)} vertical />
                            <MDBStep icon="pencil-alt" stepName="Personal Data" onClick={this.swapFormActive(3)(2)} vertical />
                            <MDBStep far icon="image" stepName="Terms and Conditions" onClick={this.swapFormActive(3)(3)} vertical />
                            <MDBStep icon="check" stepName="Finish" onClick={this.swapFormActive(3)(4)} vertical />
                          </MDBStepper>
                        </MDBCol>
  
                        <MDBCol md="7">
                          {this.state.formActivePanel3 === 1 && (
                          <MDBCol md="12">
                            <h3 className="font-weight-bold pl-0 my-4">
                              <strong>Basic Information</strong>
                            </h3>
                            <MDBInput label="Email" className="mt-4" autoFocus={this.calculateAutofocus(3)} />
                            <MDBInput label="Username" className="mt-4" />
                            <MDBInput label="Password" className="mt-4" />
                            <MDBInput label="Repeat Password" className="mt-4" />
                            <MDBBtn color="mdb-color" rounded className="float-right" onClick={this.handleNextPrevClick(3)(2)}>
                              next
                            </MDBBtn>
                          </MDBCol>
                          )}
                          {this.state.formActivePanel3 === 2 && (
                          <MDBCol md="12">
                            <h3 className="font-weight-bold pl-0 my-4">
                              <strong>Personal Data</strong>
                            </h3>
                            <MDBInput label="First Name" className="mt-3" autoFocus={this.calculateAutofocus(3)} />
                            <MDBInput label="Second Name" className="mt-3" />
                            <MDBInput label="Surname" className="mt-3" />
                            <MDBInput label="Address" type="textarea" rows="2" />
                            <MDBBtn color="mdb-color" rounded className="float-left" onClick={this.handleNextPrevClick(3)(1)}>
                              previous
                            </MDBBtn>
                            <MDBBtn color="mdb-color" rounded className="float-right" onClick={this.handleNextPrevClick(3)(3)}>
                              next
                            </MDBBtn>
                          </MDBCol>
                          )}
                          {this.state.formActivePanel3 === 3 && (
                          <MDBCol md="12">
                            <h3 className="font-weight-bold pl-0 my-4">
                              <strong>Terms and conditions</strong>
                            </h3>
                            <MDBInput label="I agreee to the terms and conditions" type="checkbox" id="checkbox3" autoFocus={this.calculateAutofocus(3)} />
                            <MDBInput label="I want to receive newsletter" type="checkbox" id="checkbox4" />
                            <MDBBtn color="mdb-color" rounded className="float-left" onClick={this.handleNextPrevClick(3)(2)}>
                              previous
                            </MDBBtn>
                            <MDBBtn color="mdb-color" rounded className="float-right" onClick={this.handleNextPrevClick(3)(4)}>
                              next
                            </MDBBtn>
                          </MDBCol>
                          )}
                          {this.state.formActivePanel3 === 4 && (
                          <MDBCol md="12">
                            <h3 className="font-weight-bold pl-0 my-4">
                              <strong>Finish</strong>
                            </h3>
                            <h2 className="text-center font-weight-bold my-4">
                              Registration completed!
                            </h2>
                            <MDBBtn color="mdb-color" rounded className="float-left" onClick={this.handleNextPrevClick(3)(3)}>
                              previous
                            </MDBBtn>
                            <MDBBtn color="success" rounded className="float-right" onClick={this.handleSubmission}>
                              submit
                            </MDBBtn>
                          </MDBCol>
                          )}
                        </MDBCol>
                      </MDBRow>
                    </MDBCardBody>
                  </MDBCard>
                </MDBContainer>
              );
            };
          }
  
          export default StepperExample;
      
        
    

Steps within form

Steps form example

1

Step 1

2

Step 2

3

Step 3

Step 1

Step 2

Step 3

        
            
          import React from "react";
          import {
            MDBContainer,
            MDBRow,
            MDBCol,
            MDBStepper,
            MDBStep,
            MDBBtn,
            MDBCard,
            MDBCardBody,
            MDBInput
          } from "mdbreact";
  
          class StepperExample extends React.Component {
            state = {
              formActivePanel1: 1,
              formActivePanel1Changed: false,
            }
  
            swapFormActive = (a) => (param) => (e) => {
              this.setState({
                ['formActivePanel' + a]: param,
                ['formActivePanel' + a + 'Changed']: true
              });
            }
  
            handleNextPrevClick = (a) => (param) => (e) => {
              this.setState({
                ['formActivePanel' + a]: param,
                ['formActivePanel' + a + 'Changed']: true
              });
            }
  
            handleSubmission = () => {
              alert('Form submitted!');
            }
  
            calculateAutofocus = (a) => {
              if (this.state['formActivePanel' + a + 'Changed']) {
                return true
              }
            }
  
            render() {
              return (
                <MDBContainer>
                  <MDBRow>
                    <MDBCol xl="6" lg="7" md="10">
                      <MDBCard>
                        <MDBCardBody>
                          <h2 className="text-center font-weight-bold pt-4 pb-5">
                            <strong>Steps form example</strong>
                          </h2>
                          <MDBStepper form>
                            <MDBStep form>
                              <a href="#formstep1" onClick={this.swapFormActive(1)(1)}>
                                <MDBBtn color={ this.state.formActivePanel1===1 ? "indigo" : "default" } circle>
                                  1
                                </MDBBtn>
                              </a>
                              <p>MDBStep 1</p>
                            </MDBStep>
                            <MDBStep form>
                              <a href="#formstep2" onClick={this.swapFormActive(1)(2)}>
                                <MDBBtn color={ this.state.formActivePanel1===2 ? "indigo" : "default" } circle>
                                  2
                                </MDBBtn>
                              </a>
                              <p>MDBStep 2</p>
                            </MDBStep>
                            <MDBStep form>
                              <a href="#formstep3" onClick={this.swapFormActive(1)(3)}>
                                <MDBBtn color={ this.state.formActivePanel1===3 ? "indigo" : "default" } circle>
                                  3
                                </MDBBtn>
                              </a>
                              <p>MDBStep 3</p>
                            </MDBStep>
                          </MDBStepper>
  
                          <form action="" method="post">
                            <MDBRow>
                              {this.state.formActivePanel1 === 1 && (
                              <MDBCol md="12">
                                <h3 className="font-weight-bold pl-0 my-4">
                                  <strong>MDBStep 1</strong>
                                </h3>
                                <MDBInput label="First Name" className="mt-3" autoFocus={this.calculateAutofocus(1)} />
                                <MDBInput label="Last Name" className="mt-3" />
                                <MDBInput label="Address" type="textarea" rows="2" />
                                <MDBBtn color="indigo" rounded className="float-right" onClick={this.handleNextPrevClick(1)(2)}>
                                  next
                                </MDBBtn>
                              </MDBCol>
                              )}
                              {this.state.formActivePanel1 === 2 && (
                              <MDBCol md="12">
                                <h3 className="font-weight-bold pl-0 my-4">
                                  <strong>MDBStep 2</strong>
                                </h3>
                                <MDBInput label="Company Name" className="mt-4" autoFocus={this.calculateAutofocus(1)} />
                                <MDBInput label="Company Address" className="mt-4" />
                                <MDBBtn color="indigo" rounded className="float-left" onClick={this.handleNextPrevClick(1)(1)}>
                                  previous
                                </MDBBtn>
                                <MDBBtn color="indigo" rounded className="float-right" onClick={this.handleNextPrevClick(1)(3)}>
                                  next
                                </MDBBtn>
                              </MDBCol>
                              )}
                              {this.state.formActivePanel1 === 3 && (
                              <MDBCol md="12">
                                <h3 className="font-weight-bold pl-0 my-4">
                                  <strong>MDBStep 3</strong>
                                </h3>
                                <MDBBtn color="indigo" rounded className="float-left" onClick={this.handleNextPrevClick(1)(2)}
                                  autoFocus={this.calculateAutofocus(1)}>
                                  previous
                                </MDBBtn>
                                <MDBBtn color="default" rounded className="float-right" onClick={this.handleSubmission}>
                                  submit
                                </MDBBtn>
                              </MDBCol>
                              )}
                            </MDBRow>
                          </form>
                        </MDBCardBody>
                      </MDBCard>
                    </MDBCol>
                  </MDBRow>
                </MDBContainer>
              );
            };
          }
  
          export default StepperExample;
      
        
    

Horizontal steppers

This form of the stepper is a simple ul-based wrapper, open for custom interactions to be designed. Below is a suggested take on the implementation.

        
            
          import React from "react";
          import { MDBContainer, MDBStepper, MDBStep, MDBIcon } from "mdbreact";
  
          const StepperExample = () => {
            return (
              <MDBContainer>
                <MDBStepper>
                  <MDBStep className="completed">
                    <a href="#!">
                      <span className="circle">1</span>
                      <span className="label">First step</span>
                    </a>
                  </MDBStep>
                  <MDBStep className="active">
                    <a href="#!">
                      <span className="circle">2</span>
                      <span className="label">Second step</span>
                    </a>
                  </MDBStep>
                  <MDBStep className="warning">
                    <a href="#!">
                      <span className="circle">
                        <MDBIcon icon="exclamation-triangle" />
                      </span>
                      <span className="label">Third step</span>
                    </a>
                  </MDBStep>
                </MDBStepper>
              </MDBContainer>
            );
          }
  
          export default StepperExample;
  
      
        
    

Vertical steppers

  • 1 First step
  • 2 Second step

    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente.

    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolore error excepturi veniam nemo repellendus, distinctio soluta vitae at sit saepe. Optio eaque quia excepturi adipisci pariatur totam, atque odit fugiat.

    Deserunt voluptatem illum quae nisi soluta eum perferendis nesciunt asperiores tempore saepe reiciendis, vero quod a dolor corporis natus qui magni quas fuga rem excepturi laboriosam. Quisquam expedita ab fugiat.

  • Third step
  • 4 Fourth step
        
            
          import React from "react";
          import {
            MDBContainer,
            MDBStepper,
            MDBStep,
            MDBIcon,
            MDBRow,
            MDBCol,
            MDBBtn
          } from "mdbreact";
  
          const StepperExample = () => {
            return (
              <MDBContainer>
                <MDBStepper vertical>
                  <MDBStep className="completed">
                    <a href="#!">
                      <span className="circle">1</span>
                      <span className="label">First step</span>
                    </a>
                  </MDBStep>
                  <MDBStep className="active">
                    <a href="#!">
                      <span className="circle">2</span>
                      <span className="label">Second step</span>
                    </a>
                    <div className="step-content grey lighten-4">
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse
                        cupiditate voluptate facere iusto quaerat vitae excepturi,
                        accusantium ut aliquam repellat atque nesciunt nostrum
                        similique. Inventore nostrum ut, nobis porro sapiente.
                      </p>
                      <p>
                        Lorem ipsum dolor sit amet, consectetur adipisicing elit.
                        Dolore error excepturi veniam nemo repellendus, distinctio
                        soluta vitae at sit saepe. Optio eaque quia excepturi adipisci
                        pariatur totam, atque odit fugiat.
                      </p>
                      <p>
                        Deserunt voluptatem illum quae nisi soluta eum perferendis
                        nesciunt asperiores tempore saepe reiciendis, vero quod a
                        dolor corporis natus qui magni quas fuga rem excepturi
                        laboriosam. Quisquam expedita ab fugiat.
                      </p>
                    </div>
                  </MDBStep>
                  <MDBStep className="warning">
                    <a href="#!">
                      <span className="circle">
                        <MDBIcon icon="exclamation-triangle" />
                      </span>
                      <span className="label">Third step</span>
                    </a>
                  </MDBStep>
                  <MDBStep>
                    <a href="#!">
                      <span className="circle">4</span>
                      <span className="label">Fourth step</span>
                    </a>
                  </MDBStep>
                  <MDBRow className="mt-1">
                    <MDBCol md="12" className="text-right">
                      <MDBBtn flat>Cancel</MDBBtn>
                      <MDBBtn color="primary">Next </MDBBtn>
                    </MDBCol>
                  </MDBRow>
                </MDBStepper>
              </MDBContainer>
            );
          }
  
          export default StepperExample;
  
  
      
        
    

React Stepper - API

In this section you will find advanced information about the Stepper component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use in working with it.


Import statement

        
            
         import { MDBStepper, MDBStep } from "mdbreact";
        
        
    

API Reference: MDBStepper Properties

The table below shows the configuration options of the MDBStepper component.

Name Type Default Description Example
className String Adds custom class to the Stepper component <MDBStepper className="myClass" />
form Boolean false Adds proper styles when MDBStepper is used as a form. <MDBStepper form />
icon Boolean Adds proper styles when MDBStepper uses buttons with icons <MDBStepper icon />
vertical Boolean false Controls whether the generated stepper should be oriented vertically <MDBStepper vertical />

API Reference: MDBStep Properties

The table below shows the configuration options of the MDBStep component.

Name Type Default Description Example
tag String Defines custom HTML tag for MDBStep Component <MDBStep tag='div' />
:fas, far, fab, fal, fad Boolean fa Defines Font Awesome style. Recomend to use with icon props <MDBStep far />
form Boolean false Adds custom styles, when you use MDBStepper as a form <MDBStep form />
icon String Defines icon used within MDBStep <MDBStep far icon="folder-open" />
stepName String Specifies the text content within MDBStep's tooltip which is visible on hover event <MDBStep stepName="Basic Information" />
vertical Boolean false Should be used whenever MDBStepper is oriented vertically <MDBStep vertical />

Angular Bootstrap Steppers

Angular Steps (stepper) - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Angular Bootstrap stepper is a component that displays content as a process with defined by user milestones. Following steps are separated and connected by buttons.

This is a great solution for a variety of registration forms, where you don't want to scare the user with loads of fields and questions.

Stepper can be aligned vertically as well as horizontally.

Examples of Bootstrap steps use:

  • Registration form
  • Payment gateway
  • Tutorial with steps

See the following Bootstrap stepper examples:


Basic horizontal steppers

        
            
          <!-- Horizontal Steppers -->
          <div class="row">
            <div class="col-md-12">

              <!-- Stepers Wrapper -->
              <ul class="stepper stepper-horizontal">

                <!-- First Step -->
                <li class="completed">
                  <a href="#!">
                    <span class="circle">1</span>
                    <span class="label">First step</span>
                  </a>
                </li>

                <!-- Second Step -->
                <li class="active">
                  <a href="#!">
                    <span class="circle">2</span>
                    <span class="label">Second step</span>
                  </a>
                </li>

                <!-- Third Step -->
                <li class="warning">
                  <a href="#!">
                    <span class="circle"><mdb-icon fas icon="exclamation"></mdb-icon></span>
                    <span class="label">Third step</span>
                  </a>
                </li>

              </ul>
              <!-- /.Stepers Wrapper -->

            </div>
          </div>
          <!-- /.Horizontal Steppers -->
        
        
    

Basic vertical steppers

  • 1 First step
  • 2 Second step

    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore nostrum ut, nobis porro sapiente.

    Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolore error excepturi veniam nemo repellendus, distinctio soluta vitae at sit saepe. Optio eaque quia excepturi adipisci pariatur totam, atque odit fugiat.

    Deserunt voluptatem illum quae nisi soluta eum perferendis nesciunt asperiores tempore saepe reiciendis, vero quod a dolor corporis natus qui magni quas fuga rem excepturi laboriosam. Quisquam expedita ab fugiat.

  • Third step
  • 4 Fourth step
        
            
          <!-- Vertical Steppers -->
          <div class="row mt-1">
            <div class="col-md-12">

              <!-- Stepers Wrapper -->
              <ul class="stepper stepper-vertical">

                <!-- First Step -->
                <li class="completed">
                  <a href="#!">
                    <span class="circle">1</span>
                    <span class="label">First step</span>
                  </a>
                </li>

                <!-- Second Step -->
                <li class="active">

                  <!--Section Title -->
                  <a href="#!">
                    <span class="circle">2</span>
                    <span class="label">Second step</span>
                  </a>

                  <!-- Section Description -->
                  <div class="step-content grey lighten-3">
                    <p>
                      Lorem ipsum dolor sit amet, consectetur adipisicing elit. Esse cupiditate voluptate facere
                      iusto quaerat vitae excepturi, accusantium ut aliquam repellat atque nesciunt nostrum similique. Inventore
                      nostrum ut, nobis porro sapiente.
                    </p>
                    <p>
                      Lorem ipsum dolor sit amet, consectetur adipisicing elit. Dolore error excepturi veniam nemo
                      repellendus, distinctio soluta vitae at sit saepe. Optio eaque quia excepturi adipisci pariatur
                      totam, atque odit fugiat.
                    </p>
                    <p>
                      Deserunt voluptatem illum quae nisi soluta eum perferendis nesciunt asperiores tempore saepe
                      reiciendis, vero quod a dolor corporis natus qui magni quas fuga rem excepturi laboriosam. Quisquam
                      expedita ab fugiat.
                    </p>
                  </div>
                </li>

                <!-- Third Step -->
                <li class="warning">
                  <a href="#!">
                    <span class="circle"><mdb-icon fas icon="exclamation"></mdb-icon></span>
                    <span class="label">Third step</span>
                  </a>
                </li>

                <!-- Fourth Step -->
                <li>
                  <a href="#!">
                    <span class="circle">4</span>
                    <span class="label">Fourth step</span>
                  </a>
                </li>

              </ul>
              <!-- /.Stepers Wrapper -->

            </div>
          </div>

          <!-- Steppers Navigation -->
          <div class="row mt-1">
            <div class="col-md-12 text-right">
              <button mdbBtn flat="true" size="sm">Cancel</button>
              <button mdbBtn color="primary" size="sm">Next</button>
            </div>
          </div>
          <!-- /.Vertical Steppers -->
        
        
    

Linear Stepper MDB Pro component

Linear stepper is a compontent which is the most common. If you need to activate linear mode, add [linear]="true" input to the mdb-stepper component.

When you are working with this stepper you have to put a correct values to do more steps.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            
          <mdb-stepper #stepper [linear]="true">
            <mdb-step name="Step 1" [stepForm]="firstFormGroup">
              <form [formGroup]="firstFormGroup">
                <div class="md-form">
                  <input type="text" class="form-control" mdbInput mdbValidate formControlName="email">
                  <label for="">Email</label>
                  <mdb-error *ngIf="email.invalid && (email.dirty || email.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="email.valid && (email.dirty || email.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
            </mdb-step>
            <mdb-step name="Step 2" [stepForm]="secondFormGroup">
              <form [formGroup]="secondFormGroup">
                <div class="md-form">
                  <input type="password" class="form-control" mdbInput mdbValidate formControlName="password">
                  <label for="">Password</label>
                  <mdb-error *ngIf="password.invalid && (password.dirty || password.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="password.valid && (password.dirty || password.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
              <button mdbBtn size="sm" color="secondary" (click)="stepper.previous()">BACK</button>
            </mdb-step>
            <mdb-step name="Step 3" label="Step 3 label">
              <p class="pl-2">Finish!</p>
              <div class="step-actions">
                <button mdbBtn  size="sm" color="primary" (click)="onSubmit()">SUBMIT</button>
              </div>
            </mdb-step>
          </mdb-stepper>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';
          import { FormGroup, FormControl, Validators } from '@angular/forms';

          @Component({
            selector: 'linear-stepper',
            templateUrl: './linear-stepper.component.html',
          })
          export class LinearStepperComponent implements OnInit {
            firstFormGroup: FormGroup;
            secondFormGroup: FormGroup;

            ngOnInit() {
              this.firstFormGroup = new FormGroup({
                email: new FormControl('', [Validators.required, Validators.email])
              });
              this.secondFormGroup = new FormGroup({
                password: new FormControl('', Validators.required)
              });
            }

            get email() { return this.firstFormGroup.get('email'); }
            get password() { return this.secondFormGroup.get('password'); }

            onSubmit() {
              // do something here
            }
          }
        
        
    

Non-linear Stepper MDB Pro component

With non linear stepper you can navigate freely between every steps.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            
          <mdb-stepper #stepper>
            <mdb-step name="Step 1" [stepForm]="firstFormGroup">
              <form [formGroup]="firstFormGroup">
                <div class="md-form">
                  <input type="text" class="form-control" mdbInput mdbValidate formControlName="email">
                  <label for="">Email</label>
                  <mdb-error *ngIf="email.invalid && (email.dirty || email.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="email.valid && (email.dirty || email.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
            </mdb-step>
            <mdb-step name="Step 2" [stepForm]="secondFormGroup">
              <form [formGroup]="secondFormGroup">
                <div class="md-form">
                  <input type="password" class="form-control" mdbInput mdbValidate formControlName="password">
                  <label for="">Password</label>
                  <mdb-error *ngIf="password.invalid && (password.dirty || password.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="password.valid && (password.dirty || password.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
              <button mdbBtn size="sm" color="secondary" (click)="stepper.previous()">BACK</button>
            </mdb-step>
            <mdb-step name="Step 3" label="Step 3 label">
              <p class="pl-2">Finish!</p>
              <div class="step-actions">
                <button mdbBtn  size="sm" color="primary" (click)="onSubmit()">SUBMIT</button>
              </div>
            </mdb-step>
          </mdb-stepper>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';
          import { FormGroup, FormControl, Validators } from '@angular/forms';

          @Component({
            selector: 'non-linear-stepper',
            templateUrl: './non-linear-stepper.component.html',
          })
          export class NonLinearStepperComponent implements OnInit {
            firstFormGroup: FormGroup;
            secondFormGroup: FormGroup;

            ngOnInit() {
              this.firstFormGroup = new FormGroup({
                email: new FormControl('', [Validators.required, Validators.email])
              });
              this.secondFormGroup = new FormGroup({
                password: new FormControl('', Validators.required)
              });
            }

            get email() { return this.firstFormGroup.get('email'); }
            get password() { return this.secondFormGroup.get('password'); }

            onSubmit() {
              // do something here
            }
          }
        
        
    

Vertical Stepper MDB Pro component

By default steppers have horizontal orientation. In order to chanage it to vertical, you need to use [vertical]="true" input.

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            
          <mdb-stepper #stepper [vertical]="true">
            <mdb-step name="Step 1" label="Type something" [stepForm]="firstFormGroup">
              <form [formGroup]="firstFormGroup">
                <div class="md-form">
                  <input type="text" class="form-control" mdbInput mdbValidate formControlName="email">
                  <label for="">Email</label>
                  <mdb-error *ngIf="email.invalid && (email.dirty || email.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="email.valid && (email.dirty || email.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
            </mdb-step>
            <mdb-step name="Step 2" [stepForm]="secondFormGroup">
              <form [formGroup]="secondFormGroup">
                <div class="md-form">
                  <input type="password" class="form-control" mdbInput mdbValidate formControlName="password">
                  <label for="">Password</label>
                  <mdb-error *ngIf="password.invalid && (password.dirty || password.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="password.valid && (password.dirty || password.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
              <button mdbBtn size="sm" color="secondary" (click)="stepper.previous()">BACK</button>
            </mdb-step>
            <mdb-step name="Step 3" label="Step 3 label">
              <p class="pl-2">Finish!</p>
              <div class="step-actions">
                <button mdbBtn  size="sm" color="primary" (click)="onSubmit()">SUBMIT</button>
              </div>
            </mdb-step>
          </mdb-stepper>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';
          import { FormGroup, FormControl, Validators } from '@angular/forms';

          @Component({
            selector: 'vertical-stepper',
            templateUrl: './vertical-stepper.component.html',
          })
          export class VerticalStepperComponent implements OnInit {
            firstFormGroup: FormGroup;
            secondFormGroup: FormGroup;

            ngOnInit() {
              this.firstFormGroup = new FormGroup({
                email: new FormControl('', [Validators.required, Validators.email])
              });
              this.secondFormGroup = new FormGroup({
                password: new FormControl('', Validators.required)
              });
            }

            get email() { return this.firstFormGroup.get('email'); }
            get password() { return this.secondFormGroup.get('password'); }

            onSubmit() {
              // do something here
            }
          }
        
        
    

Stepper with shadow MDB Pro component

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            
          <div class="z-depth-1 m-2">
            <div class="div p-4">
              <mdb-stepper #stepper [vertical]="true">
                <mdb-step name="Step 1" label="Type something" [stepForm]="firstFormGroup">
                  <form [formGroup]="firstFormGroup">
                    <div class="md-form">
                      <input type="text" class="form-control" mdbInput mdbValidate formControlName="email">
                      <label for="">Email</label>
                      <mdb-error *ngIf="email.invalid && (email.dirty || email.touched)">Input invalid</mdb-error>
                      <mdb-success *ngIf="email.valid && (email.dirty || email.touched)">Input valid</mdb-success>
                    </div>
                  </form>
                  <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
                </mdb-step>
                <mdb-step name="Step 2" [stepForm]="secondFormGroup">
                  <form [formGroup]="secondFormGroup">
                    <div class="md-form">
                      <input type="password" class="form-control" mdbInput mdbValidate formControlName="password">
                      <label for="">Password</label>
                      <mdb-error *ngIf="password.invalid && (password.dirty || password.touched)">Input invalid</mdb-error>
                      <mdb-success *ngIf="password.valid && (password.dirty || password.touched)">Input valid</mdb-success>
                    </div>
                  </form>
                  <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
                  <button mdbBtn size="sm" color="secondary" (click)="stepper.previous()">BACK</button>
                </mdb-step>
                <mdb-step name="Step 3" label="Step 3 label">
                  <p class="pl-2">Finish!</p>
                  <div class="step-actions">
                    <button mdbBtn size="sm" color="primary" (click)="onSubmit()">SUBMIT</button>
                  </div>
                </mdb-step>
              </mdb-stepper>
            </div>
          </div>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';
          import { FormGroup, FormControl, Validators } from '@angular/forms';

          @Component({
            selector: 'stepper-with-shadow',
            templateUrl: './stepper-with-shadow.component.html',
          })
          export class StepperWithShadowComponent implements OnInit {
            firstFormGroup: FormGroup;
            secondFormGroup: FormGroup;

            ngOnInit() {
              this.firstFormGroup = new FormGroup({
                email: new FormControl('', [Validators.required, Validators.email])
              });
              this.secondFormGroup = new FormGroup({
                password: new FormControl('', Validators.required)
              });
            }

            get email() { return this.firstFormGroup.get('email'); }
            get password() { return this.secondFormGroup.get('password'); }

            onSubmit() {
              // do something here
            }
          }
        
        
    

Stepper with icon MDB Pro component

  • Step 1
  • Step 2
  • Step 3
    Finish!
        
            
          <mdb-stepper #stepper [linear]="true">
            <mdb-step name="Step 1" [stepForm]="firstFormGroup" class="step1">
              <form [formGroup]="firstFormGroup">
                <div class="md-form">
                  <input type="text" class="form-control" mdbInput mdbValidate formControlName="email">
                  <label for="">Email</label>
                  <mdb-error *ngIf="email.invalid && (email.dirty || email.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="email.valid && (email.dirty || email.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
            </mdb-step>
            <mdb-step name="Step 2" [stepForm]="secondFormGroup" class="step2">
              <form [formGroup]="secondFormGroup">
                <div class="md-form">
                  <input type="password" class="form-control" mdbInput mdbValidate formControlName="password">
                  <label for="">Password</label>
                  <mdb-error *ngIf="password.invalid && (password.dirty || password.touched)">Input invalid</mdb-error>
                  <mdb-success *ngIf="password.valid && (password.dirty || password.touched)">Input valid</mdb-success>
                </div>
              </form>
              <button mdbBtn size="sm" color="primary" (click)="stepper.next()">CONTINUE</button>
              <button mdbBtn size="sm" color="secondary" (click)="stepper.previous()">BACK</button>
            </mdb-step>
            <mdb-step name="Step 3" label="Step 3 label" class="step3">
              <p class="pl-2">Finish!</p>
              <div class="step-actions">
                <button mdbBtn  size="sm" color="primary" (click)="onSubmit()">SUBMIT</button>
              </div>
            </mdb-step>
          </mdb-stepper>
        
        
    
        
            
          import { Component, OnInit } from '@angular/core';
          import { FormGroup, FormControl, Validators } from '@angular/forms';

          @Component({
            selector: 'stepper-with-icon',
            templateUrl: './stepper-with-icon.component.html',
          })
          export class SteppersWithIcons implements OnInit {
            firstFormGroup: FormGroup;
            secondFormGroup: FormGroup;

            ngOnInit() {
              this.firstFormGroup = new FormGroup({
                email: new FormControl('', [Validators.required, Validators.email])
              });
              this.secondFormGroup = new FormGroup({
                password: new FormControl('', Validators.required)
              });
            }

            get email() { return this.firstFormGroup.get('email'); }
            get password() { return this.secondFormGroup.get('password'); }

            onSubmit() {
              // do something here
            }
          }
        
        
    
        
            
          ul.stepper.horizontal .step .step-title::before {
            font-weight: 900;
            font-family: "Font Awesome 5 Free";
          }

          ul.stepper.horizontal .step:nth-of-type(1) .step-title {
            &:before {
              content: "\f007";
            }
          }

          ul.stepper.horizontal .step:nth-of-type(2) .step-title {
            &:before {
              content: "\f004";
            }
          }

          ul.stepper.horizontal .step:nth-of-type(3) .step-title {
            &:before {
              content: "\f005";
            }
          }
        
        
    

Angular Steppers - API

In this section you will find informations about required modules and available inputs of stepper component.


Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

        
            
          import { StepperModule, WavesModule } from 'ng-uikit-pro-standard'
        
        
    
        
            
          import { WavesModule } from 'angular-bootstrap-md'
        
        
    

Components

MdbStepper

Selector: mdb-stepper

Type: MdbStepperComponent

MdbStep

Selector: mdb-step

Type: MdbStepComponent


Inputs

MdbStepper
Name Type Default Description Example
disableWaves boolean false Allow to toggle waves effects [disableWaves]="true"
linear boolean false Allow to toggle linear mode [linear]="true"
vertical boolean false Allow to change stepper orientation to vertical [vertical]="true"
MdbStep
Name Type Default Description Example
editable boolean false Allow to disable edition of finished step [editable]="true"
name string - Allow to add title for specific step [name]="'Step title'"
label string - Allow to add label text for specific step [label]="'Step label'"
stepForm FormGroup - Allow to assign FormGroup element to specific step (used for validation) [stepForm]="fromGroupName"

Methods

You can get access to stepper methods from another component. Add template reference variable to your mdb-stepper component in HTML file

<mdb-stepper #stepper></mdb-stepper>

Then in your typescript file use @ViewChild decorator to get access to MdbStepper methods

@ViewChild('stepper', { static: true }) stepper: MdbStepperComponent

MdbStepper
Name Description Example
next Allow to set next step as active this.stepper.next()
previous Allow to set previous step as active this.stepper.previous()
setNewActiveStep(index: number) Allow to set active state on the step with specified index this.stepper.setNewActiveStep(1)
resetAll Allow to reset all steps and set first step as active this.stepper.resetAll()